//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		angeliris_compiler.h
 * @brief		angelscript RpC t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2012, Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see LICENSE
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_angeliris_compiler_H_
#define INCG_IRIS_angeliris_compiler_H_

//======================================================================
// include
#include "angeliris_module.h"

namespace angeliris
{

//======================================================================
// class
/**
 * @ingroup	as
 * @brief	AngelScript Compiler NX
*/
class CAsCompiler
{
	asIScriptModule*	m_pModule;	//!< W[
public:
	// RXgN^
	CAsCompiler(void);
	// fXgN^
	~CAsCompiler(void);

public:
	// 
	bool	Initialize(asIScriptModule* module);
	// t@CCN[h
	int		Include(const char* lpszFileName);
	// rh
	int		Build(void);

public:
	// W[̐ݒ
	void	SetModule(asIScriptModule* module)	{ m_pModule = module; }
	// W[̎擾
	asIScriptModule*	GetModule(void)	const	{ return m_pModule; }

private:
	// vvZX
	int		Preprocess(void* buf, u32 size);
};

}	// end of namespace angeliris

#endif
