//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		angeliris_error.h
 * @brief		angelscript G[ t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 *
 * @par			copyright
 * Copyright (C) 2012, Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see LICENSE
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_angeliris_error_H_
#define INCG_IRIS_angeliris_error_H_

//======================================================================
// include
#include "angeliris_inchead.h"

namespace angeliris
{

//======================================================================
// function
void	AsFormatMessage (int Error, LPTSTR lpBuf, size_t size);
void	AsFormatMessageA(int Error, LPSTR  lpBuf, size_t size);
void	AsFormatMessageW(int Error, LPWSTR lpBuf, size_t size);

}	// end of namespace angeliris

//======================================================================
// define
#ifdef _DEBUG

#define AS_ASSERT(Error)				do { if( AS_FAILED(Error) ) { TCHAR err_str[256]; ::angeliris::AsFormatMessage(Error, err_str, 256); _tprintf(TEXT("*** FILED: ") TEXT(__FILE__) TEXT("(%d) :<%s>.\n")  , __LINE__, err_str); } } while(0)
#define AS_ASSERT_MSG(Error, comm)		do { if( AS_FAILED(Error) ) { TCHAR err_str[256]; ::angeliris::AsFormatMessage(Error, err_str, 256); _tprintf(TEXT("*** FILED: ") TEXT(__FILE__) TEXT("(%d) %s:<%s>.\n"), __LINE__, comm, err_str); } } while(0)

#else

#define AS_ASSERT(Error)				(void)(0)
#define AS_ASSERT_MSG(Error, comm)		(void)(0)

#endif

#endif
