//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		angeliris_module.h
 * @brief		angelscript W[ t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2012, Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see LICENSE
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_angeliris_module_H_
#define INCG_IRIS_angeliris_module_H_

//======================================================================
// include
#include "angeliris_inchead.h"

namespace angeliris
{

//======================================================================
// class
/**
 * @ingroup	as
 * @brief	AngelScript Module NX
*/
class CAsModule
{
	typedef asIScriptModule*	value_type;
public:
	// RXgN^
	CAsModule(void);
	// fXgN^
	~CAsModule(void);

public:
	// 
	bool	Initialize(asIScriptModule* module);

	// ֐̎擾
	LPCSTR	GetFunctionName(int funcId) const;

public:
	CAsModule&	operator =	(asIScriptModule* obj)	{ m_module = obj; return *this; }
	CAsModule&	operator =	(const CAsModule& obj)	{ m_module = obj.m_module; return *this; }

public:
	operator			value_type			(void)			{ return m_module; }
	operator			const value_type	(void)	const	{ return m_module; }
	value_type			operator -> (void)			{ return m_module; }
	const value_type	operator -> (void)	const	{ return m_module; }

	bool	is_valid(void)	const { return m_module != NULL; }

private:
	asIScriptModule*	m_module;
};

}	// end of namespace angeliris

#endif
