//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		angeliris_printer.h
 * @brief		angelscript ostream t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 *
 * @par			copyright
 * Copyright (C) 2012, Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see LICENSE
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_angeliris_printer_H_
#define INCG_IRIS_angeliris_printer_H_

//======================================================================
// include
#include "angeliris_variant.h"
#include <ostream>

namespace angeliris
{

inline std::ostream& operator << (std::ostream& o, const CAsVariant& v)
{
	switch( v.GetFlag() )
	{
	case asTYPEID_BOOL:
		return o << v.GetVar().b;
	case asTYPEID_INT8:
		return o << v.GetVar().i8;
	case asTYPEID_INT16:
		return o << v.GetVar().i16;
	case asTYPEID_INT32:
		return o << v.GetVar().i32;
	case asTYPEID_INT64:
		return o << v.GetVar().i64;
	case asTYPEID_UINT8:
		return o << v.GetVar().ui8;
	case asTYPEID_UINT16:
		return o << v.GetVar().ui16;
	case asTYPEID_UINT32:
		return o << v.GetVar().ui32;
	case asTYPEID_UINT64:
		return o << v.GetVar().ui64;
	case asTYPEID_FLOAT:
		return o << v.GetVar().f32;
	case asTYPEID_DOUBLE:
		return o << v.GetVar().f64;
	};
	return o << v.GetVar().obj;
}

#endif