//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		angeliris_system.h
 * @brief		angelscript VXe t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2012, Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see LICENSE
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_angeliris_system_H_
#define INCG_IRIS_angeliris_system_H_

//======================================================================
// include
#include "angeliris_inchead.h"
#include "angeliris_context.h"

namespace angeliris
{

//======================================================================
// class
/**
 * @ingroup	as
 * @brief	AngelScript System NX
*/
class CAsSystem : public CObserverSubject<CAsContext>
{
	friend class CAsContext;
protected:
	asIScriptEngine*	m_pEngine;	//!< XNvgGW

public:
	// RXgN^
	CAsSystem(void);
	// fXgN^
	~CAsSystem(void);

public:
	// 
	bool	Initialize(void);
	// I
	void	Terminate(void);

public:
	// ReLXg̍쐬
	bool	CreateContext(CAsContext& context);

public:
	// W[̍쐬
	asIScriptModule*	CreateModule(LPCSTR lpszModuleName);
	// W[̎擾
	asIScriptModule*	GetModule(LPCSTR lpszModuleName);

public:
	// ֐̎擾
	LPCSTR	GetFunctionName(int funcId) const;

public:
	// ֐̎擾
	static LPCSTR	GetFunctionName(asIScriptEngine* engine, int funcId);

public:
	asIScriptEngine* GetEngine(void)	const	{ return m_pEngine; }

private:
	// OR[obN
	void	ExceptionCallback(asIScriptContext* context);

private:
	virtual	void	OnDetach(CAsContext* observer);
};

}	// end of namespace angeliris

#endif
