//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		angeliris_vm.h
 * @brief		angelscript vm t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2012, Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see LICENSE
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_angeliris_vm_H_
#define INCG_IRIS_angeliris_vm_H_

//======================================================================
// include
#include "angeliris_system.h"
#include "angeliris_compiler.h"
#include "angeliris_function.h"

namespace angeliris
{

//======================================================================
// class
/**
 * @ingroup	as
 * @brief	AngelScript Virtual Machine NX
*/
class CAsVM
{
protected:
	CAsContext	m_Context;
	CAsModule	m_Module;
	CAsSystem&	m_rSystem;
public:
	// RXgN^
	CAsVM(CAsSystem& system);
	// fXgN^
	~CAsVM(void);

public:
	// 
	bool	Initialize(const CAsCompiler& compiler);
	// s
	int		Run(const char* entry);
	// I
	void	Terminate(void);

public:
	// LȃIuWFNgǂ
	bool	IsValid(void) const;
public:
	// Functor ̐ݒ
	bool	MakeFunctor(CAsFunction& func, LPCSTR name) const;
};

}	// end of namespace angeliris

#endif
