//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		angeliris_typetraits.h
 * @brief		angelscript ^ t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 *
 * @par			copyright
 * Copyright (C) 2012, Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see LICENSE
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_angeliris_typetraits_H_
#define INCG_IRIS_angeliris_typetraits_H_

//======================================================================
// include
#include <type_traits>


#ifdef _MSC_VER
#  if _MSC_VER < 1600
#    define ANGELIRIS_TR1_TYPETRAITS	1
#  endif
#endif

namespace angeliris
{

//======================================================================
// class
/**
 * @brief	enable_if
*/
template<bool B, typename T>
struct enable_if
{
	typedef T	type;
};
template<typename T>
struct enable_if<false, T> {};

template<class COND, typename T = void>
struct enable_if_t : public enable_if<COND::value, T> {};

/**
 * @brief	disable_if
*/
template<bool B, typename T>
struct disable_if : public enable_if<!B, T> {};
template<class COND, typename T = void>
struct disable_if_t : public disable_if<COND::value, T> {};

template<typename TN>
struct enabler_t
{
	static void*	value;
};
template<typename TN>void*	enabler_t<TN>::value = NULL;

typedef enabler_t<void>	enabler;


//======================================================================
// using

#ifdef ANGELIRIS_TR1_TYPETRAITS

using ::std::tr1::is_pointer;
using ::std::tr1::remove_cv;
using ::std::tr1::is_signed;
using ::std::tr1::is_integral;

#else

#endif

}	// end of namespace angeliris

#endif
