//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		angeliris_file.h
 * @brief		FILENXt@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2012, Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see LICENSE
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_angeliris_file_H_
#define INCG_IRIS_angeliris_file_H_

//======================================================================
// include
#include <stdio.h>
#include <angeliris/angeliris_inchead.h>

namespace angeliris {
namespace detail
{

//======================================================================
// enum
/// Open [h
typedef enum
{
	FOPEN_READ		= 0x00000001,	//!< ǂݍ
	FOPEN_WRITE		= 0x00000002,	//!< 
	FOPEN_RW		= FOPEN_READ|FOPEN_WRITE,	//!< ǂݏ
	FOPEN_NONBLOCK	= 0x00000004,	//!< non blocking [h
	FOPEN_READLOCK	= 0x00000010,	//!< ǂݍ݃bN( non shared )
	FOPEN_WRITELOCK	= 0x00000020,	//!< ݃bN( non shared )
	FOPEN_APPEND	= 0x00000100,	//!< ǉ݃[h
	FOPEN_CREATE	= 0x00000200,	//!< t@CȂƂɍ쐬
	FOPEN_TRUNC		= 0x00000400,	//!< ej(0byte)ĊJ
	FOPEN_CREATENEW	= 0x00000800,	//!< FOPEN_CREATEw肵ƂɁAt@C݂ƃG[Ƃ
	FOPEN_EXCL		= 0x01000000,	//!< t@CI[vXbĥݑ싖
	FOPEN_POWERLOCK	= 0x02000000,	//!< t@C쒆̓d֎~
	FOPEN_MASK		= 0x03000f37
} OPEN_MODE;
/// seek[h
typedef enum
{
	FILE_SEEK_SET = 0,	//!< 擪
	FILE_SEEK_CUR,		//!< Jgʒu
	FILE_SEEK_END,		//!< I[
	FILE_SEEK_MODE_NUM
} SEEK_MODE;

//======================================================================
// class
//! FILENX
class CFile
{
private:
	FILE*	m_fp;	//!< t@C|C^
public:
	// set, get
	FILE*	GetFilePtr(void)	{ return m_fp; }
    // FILE*̎擾
	FILE*	operator()(void)	{ return GetFilePtr(); }
public:
	// RXgN^
	CFile(void);
	// fXgN^
	virtual ~CFile(void);

public:
	// ֘At
	bool	Attach(FILE* fp);
	// ֘At
	FILE*	Detach(void);

public:
	// J
	bool	Open (LPCTSTR lpFileName, LPCTSTR mode);
	bool	OpenA(LPCSTR  lpFileName, LPCSTR  mode);
	bool	OpenW(LPCWSTR lpFileName, LPCWSTR mode);

	// ǂݍ
	u32		Read(void* buf, u32 size, u32 n);
	// 
	u32		Write(const void* buf, u32 size, u32 n);


public:
	// J
	bool	Open (LPCSTR  lpFileName, u32 mode)		{ return OpenA(lpFileName, mode); }
	bool	Open (LPCWSTR lpFileName, u32 mode)		{ return OpenW(lpFileName, mode); }
	bool	OpenA(LPCSTR  lpFileName, u32 mode);
	bool	OpenW(LPCWSTR lpFileName, u32 mode);
	bool	IsOpen(void)	const;
	// 
	bool	Close(void);
	// seek
	bool	Seek(long offset, int origin);
	// tell
	s32		Tell(void)		const;
	// t@CTCY擾
	u32		GetSize(void)	const;

	// ǂݍ
	u32		Read(void* buf, u32 size);
	// 
	u32		Write(const void* buf, u32 size);

	// 1sǂݍ
	LPTSTR	ReadLine (LPTSTR buf, int size);
	LPSTR	ReadLineA(LPSTR  buf, int size);
	LPWSTR	ReadLineW(LPWSTR buf, int size);
};

}	// end of namespace detaile
}	// end of namespace angeliris

#endif
